package cn.pluss.platform.merchant;

import cn.pluss.platform.dto.*;
import cn.pluss.platform.entity.MerchantBaseInfo;
import cn.pluss.platform.entity.UserApp;
import cn.pluss.platform.vo.MerchantBaseInfoVO;
import cn.pluss.platform.vo.MerchantBaseNewVO;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.service.IService;

import java.io.Serializable;
import java.util.List;
import java.util.Map;

public interface MerchantBaseInfoService extends IService<MerchantBaseInfo> {

    /**
     * 上级查看商户基本信息，最多能看两级
     * @param userId  用户id
     * @return
     */
    MerchantBaseInfoVO apiGetMchDetail(String userId);


    /**
     * 获取所有的多商户列表
     * @param userId    用户id
     */
    List<MerchantBaseInfo> getAllByUserId(String userId);

    /**
     * 保存商户信息
     * @param merchantBaseInfoDTO
     */
    void saveMerchantBaseInfo(MerchantBaseInfoDTO merchantBaseInfoDTO);

    /**
     * 保存营业执照信息
     * @param businessLicenseDTO    营业执照信息参数
     */
    void saveBusinessLicense(BusinessLicenseDTO businessLicenseDTO);

    MerchantBaseInfo getMerchantBaseInfoByUserId(String userId);

    MerchantBaseInfo getMerchantBaseInfoByMerchantCode(String merchantCode);

    MerchantBaseInfo queryMerchantBaseInfo(MerchantBaseInfo merchantBaseInfo);

    /**根据id查找
     * @param id
     * @return
     */
    MerchantBaseInfo getMerchantBaseInfoById(Integer id);

    List<MerchantBaseInfo> queryMerchantBaseInfoList(MerchantBaseInfo merchantBaseInfo);

    void saveMerchantBaseInfo(MerchantBaseInfo merchantBaseInfo);

    void updateMerchantBaseInfo(MerchantBaseInfo merchantBaseInfo);

    void deleteMerchantBaseInfo(MerchantBaseInfo merchantBaseInfo);

    List<MerchantBaseInfo> queryMerchantBaseInfoPage(Map map);

    Integer queryMerchantBaseInfoPageCount(Map map);

    /**
     * 查询商户管理列表的，admin
     * @param map
     * @return
     */
    List<MerchantBaseNewVO> queryMerchantBaseNewPage(Map<String, Object> map);

    /**
     * 统计商户列表个数
     * @param map
     * @return
     */
    Integer queryMerchantBaseNewPageCount(Map<String, Object> map);

    /**
     * 添加子商户
     * @param merchantBaseInfoDTO   子商户基本信息
     */
    void saveMerchantUser(MerchantBaseInfoDTO merchantBaseInfoDTO);

    /**
     * 商户活动奖励金发放
     * @param merchantCode
     * @param consumeFee
     */
    void grantMerchantMarket(String merchantCode, Double consumeFee);

    /**
     * 关联分页查询商户信息
     * @param merchantPage
     * @param userApp
     * @return
     */
    Page<MerchantBaseInfo> pageJoinData(Page<MerchantBaseInfo> merchantPage,
                                        UserApp userApp);

    Map<String,Object> listMerchantBaseInfoPage(Integer currPage, Integer size, String column, Boolean asc, MerchantBaseNewVO merchantBaseNewVO);

    void apiSwitchBankLargePermission();

    void apiWxCertPass();

    /**
     * 统计商户交易数据详情
     * @date: 2021/12/30 17:51
     * @param page:
     * @param dto:
     * @return com.baomidou.mybatisplus.extension.plugins.pagination.Page<cn.pluss.platform.dto.MercOrderDataDTO>
     */
    Page<MercOrderDataDTO> pageData(Page<MercOrderDataDTO> page, MercOrderDataDTO dto);

    /**
     * 商户交易数据环比统计
     * @date: 2021/12/31 13:46
     * @param page:
     * @param dto:
     * @return com.baomidou.mybatisplus.extension.plugins.pagination.Page<cn.pluss.platform.dto.MercTradeDataDTO>
     */
    Page<MercTradeDataDTO> pageTradeData(Page<MercTradeDataDTO> page, MercTradeDataDTO dto);

    /**
     * 商户活跃度分析统计
     * @date: 2022/1/7 14:11
     * @param page:
     * @param dto:
     * @return com.baomidou.mybatisplus.extension.plugins.pagination.Page<cn.pluss.platform.dto.MercActiveDataDTO>
     */
    Page<MercActiveDataDTO> pageActiveData(Page<MercActiveDataDTO> page, MercActiveDataDTO dto);

    /**
     * 根据区域和角色查询商户信息
     * @date: 2022/3/1 16:33
     * @param areaList:
     * @param roleCode:
     * @return java.util.List<cn.pluss.platform.entity.MerchantBaseInfo>
     */
    List<String> getAreaAndRoleList(List<String> areaList, String roleCode);

    /**
     * 查询当前用户直推商户Code
     * @param userId
     * @return
     */
    List<String> queryNextMercCodeByUserId(Serializable userId);
}

